package com.hunk.lock.server;

import android.app.ActivityManager.RunningTaskInfo;
import android.app.KeyguardManager;
import android.app.KeyguardManager.KeyguardLock;
import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.app.Service;
import android.app.admin.DevicePolicyManager;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.os.Handler;
import android.os.IBinder;
import android.os.Message;
import android.os.PowerManager;
import android.os.PowerManager.WakeLock;
import android.widget.Toast;

import com.hunk.lock.MainActivity;
import com.hunk.lock.R;
import com.hunk.lock.UpdateActivity;
import com.hunk.lock.app.Conf;
import com.hunk.lock.app.LTApplication;
import com.hunk.lock.async.UpdateAsyncTaskTwo;
import com.hunk.lock.bean.UpdateInfo;
import com.hunk.lock.listener.AccelerometerSensorEventListener;
import com.hunk.lock.listener.ProximitySensorEventListener;
import com.hunk.lock.receiver.PowerConnectionReceiver;
import com.hunk.lock.receiver.TimePickBroadcastReceiver;
import com.hunk.lock.utils.DeBugTool.Log;
import com.hunk.lock.utils.FileUtils;
import com.hunk.lock.utils.LockUtils;
import com.hunk.lock.utils.Util;
import com.umeng.fb.FeedbackAgent;
/**
 * 
 *	@Create at  ：2013-9-22 下午10:09:42
 *	@ProjectName：LTLock
 *	@FileName   : AutoLockService.java
 *	@Copyright  : 2007-2013 Guangzhou Seed Network Tech Co,Ltd.
 *	@Company:     广州萌芽网络科技有限公司
 *				 http://www.gzseed.com/
 *	@author 	 Huang Kui 805015788@qq.com
 *	@version     1.0
 *	@since       JDK 1.6.0
 *	@Description：
 */
public class AutoLockService extends Service implements SensorEventListener {
	
	private final static String TAG = "AutoLockService";

	private boolean lock = false ;
	private SensorManager sm = null;
	//距离感应
	private Sensor promixty = null;
	// 锁频距离（单位：厘米）
	private static long time = 0 ;
	private final static int TIME_DISTANCE = 1000 ;
	
	
//	private DevicePolicyManager mDPM;
	
	private Context context ;
	private LTApplication application ;
	
	// 传感器
	private Sensor acc;
	
	// 速度阈值，当摇晃速度达到这值后产生作用
	private static final int SPEED_SHRESHOLD = 1250;
	// 两次检测的时间间隔
	private static final int UPTATE_INTERVAL_TIME = 70;

	// 手机上一个位置时重力感应坐标
	private float lastX;
	private float lastY;
	private float lastZ;
	// 上次检测时间
	private long lastUpdateTime;
	
	public final static int FLAG = 0xbfdc;

	// Notification manager to displaying arrived push notifications
	private NotificationManager mNotifMan;
	private PendingIntent pi;

	private Handler handler;
	private static Handler viewHandler ;
	private Notification notification;

	private final static int MSG_NEXT = 0x1b7d03b3;
	public final static int MSG_LATER = MSG_NEXT + 1;
	private final static int MSG_REGISTER = MSG_LATER + 1;
//	private final static int MSG_HORIZONTAL = MSG_REGISTER + 1;
//	private final static int MSG_STOP_REGISTER_LATER = MSG_REGISTER + 1;
	private final static int MSG_TIME_SLEEP_START = MSG_REGISTER + 1;
	private final static int MSG_TIME_SLEEP_FINISH = MSG_TIME_SLEEP_START + 1;
	private final static int MSG_SLEEP_WAKE = MSG_TIME_SLEEP_FINISH + 1;
	
	private WakeLock wakeLockHold ;
	
	
	private boolean isAcc = false ;
	private boolean isPro = false ;
	private boolean isRegister = false ;
	
	private Intent service ;
	
	private PowerConnectionReceiver powerConnectionReceiver;
	
	//POWER_CONNECTED
	private boolean isPowerConnected = false ;
	
	private long start ;
	private long end ;
	
	private TimePickBroadcastReceiver tiemReceiver ;
	
	private PowerManager pm ;
	private DevicePolicyManager mDPM ;
	
	private Intent  mainServer ;
	
	public static void setViewHandler(Handler viewHandler) {
		AutoLockService.viewHandler = viewHandler;
	}

	@Override
	public IBinder onBind(Intent intent) {
		// TODO Auto-generated method stub
		return null; 
	}

	@Override
	public void onCreate() {
		super.onCreate();
		if(null==application){
			application = LTApplication.getInstance();
		}
		context = this ;
		//用户反馈回复通知
		FeedbackAgent agent = new FeedbackAgent(context);
		agent.sync();
		if (null == sm) {
			sm = (SensorManager) context.getSystemService(Service.SENSOR_SERVICE); // 获取传感器管理类
			promixty = sm.getDefaultSensor(Sensor.TYPE_PROXIMITY); // 获取距离传感器
			acc = sm.getDefaultSensor(Sensor.TYPE_ACCELEROMETER);//获取加速传感器
		}
		
		//首先我们要获得android设备管理代理
		if(null==mDPM){
			mDPM = (DevicePolicyManager) getSystemService(Context.DEVICE_POLICY_SERVICE);
		}
		
		if(null==service){
			service = new Intent(context, AutoLockService.class);
			mainServer = new Intent(context, MainServer.class);
		}
		
		keyguardManager = (KeyguardManager) getSystemService(KEYGUARD_SERVICE);
		keyguardLock = keyguardManager.newKeyguardLock("LTLock");
		
		//防止休眠
		pm = (PowerManager)getSystemService(POWER_SERVICE);
		wakeLockHold = pm.newWakeLock(PowerManager.ACQUIRE_CAUSES_WAKEUP|PowerManager.SCREEN_DIM_WAKE_LOCK, "all");
		
		
		Notification localNotification = new Notification();
		localNotification.flags = (Notification.FLAG_ONGOING_EVENT | localNotification.flags);
		localNotification.flags = (Notification.FLAG_NO_CLEAR | localNotification.flags);
		localNotification.setLatestEventInfo(this, "", "", PendingIntent
				.getActivity(this, 0, new Intent(this, MainActivity.class), 0));
		startForeground(1, localNotification);
		
		
		
		mNotifMan = (NotificationManager) getSystemService(NOTIFICATION_SERVICE);
		notification = new Notification();
		notification.flags |= Notification.FLAG_AUTO_CANCEL;
		notification.icon = R.drawable.ic_launcher2;
		handler = new MyHandler();
		
		
		
		powerConnectionReceiver = new PowerConnectionReceiver() ;
		IntentFilter filter = new IntentFilter() ;
//		filter.addAction(Intent.ACTION_BATTERY_CHANGED);
//		filter.addAction(Intent.ACTION_SCREEN_OFF);
//		filter.addAction(Intent.ACTION_SCREEN_ON);
//		filter.addAction(Intent.ACTION_TIME_TICK);
		this.registerReceiver(powerConnectionReceiver, filter);
		
//		registerListener(promixty);// 注册距离感应器
		registerListener(acc);//注册加速传感器
//		AccelerometerSensorEventListener accListener = new AccelerometerSensorEventListener(context);
//		ProximitySensorEventListener proListener = new ProximitySensorEventListener(context);

		
	}
	
	
	
	@Override
	public void onStart(Intent intent, int startId) {
		if(null==intent){
			return ;
		}
		String action = intent.getAction();
		Log.e(TAG, "onStart:  "+action);
//		if(Intent.ACTION_TIME_TICK.equals(action)){
//			
//		}else 
		if(Intent.ACTION_SCREEN_ON.equals(action)){
		}else if(Intent.ACTION_SCREEN_OFF.equals(action)){
			sleepWakeAlive();
//			listenerSensor();
		}else if(Intent.ACTION_POWER_CONNECTED.equals(action)){
			
		}else if(Intent.ACTION_POWER_DISCONNECTED.equals(action)){
			
		}else if(Conf.SMS_RECEIVED_ACTION.equals(action)){
//			Toast.makeText(context, "收到新的短信！", Toast.LENGTH_LONG).show();
			Log.e(TAG, "onStart:  收到新的短信！");
//			handler.sendEmptyMessage(MSG_HORIZONTAL);
		}
	}
	
	@Override
	public int onStartCommand(Intent intent, int flags, int startId) {
		// TODO Auto-generated method stub
		flags = START_STICKY ;
		if(null==intent){
			return super.onStartCommand(intent, flags, startId);
		}
		String atction = intent.getAction();
		Log.i(TAG, "onStartCommand:  "+atction);
		if(Conf.ACTION.START_SERVICE.equals(atction)){
			update();
			if(application.isLight()){
				startService(mainServer);
			}
		}
//		if(Conf.ACTION.REGISTER_ACC.equals(atction)){
//			registerListener(acc);
//		}
//		if(Conf.ACTION.UNREGISTER_ACC.equals(atction)){
//			unregisterListener(acc);
//		}
		if(Conf.ACTION.REGISTER_PRO.equals(atction)){
//			registerListener(promixty);
			startService(mainServer);
		}
		if(Conf.ACTION.UNREGISTER_PRO.equals(atction)){
//			unregisterListener(promixty);
			stopService(mainServer);
		}
		if(Conf.ACTION.JIANCE.equals(atction)){
		}
		if(Conf.ACTION.UNJIANCE.equals(atction)){
		}
		if(Conf.ACTION.TIME_SLEEP.equals(atction)){
//			registerSleep();
		}
		
		flags = START_STICKY ;
		return super.onStartCommand(intent, flags, startId);
	}
	private WakeLock   mWakelockall ;

	@Override
	public void onDestroy() {
		if(LockUtils.isActive(this)){
			service.setAction(Conf.ACTION.START_SERVICE);
			startService(service);
		}
		super.onDestroy();
		if( null != sm ){
			//撤销监听器
			sm.unregisterListener(this);
			isAcc = false ;
			isPro = false ;
		}
		if(null!=wakeLock&&wakeLock.isHeld()){
    		wakeLock.release();
    	}
		if(null!=mWakelockall){
			mWakelockall.release();
		}
		this.unregisterReceiver(powerConnectionReceiver);
		handler.removeMessages(MSG_NEXT);
		handler.removeMessages(MSG_LATER);
		handler.removeMessages(MSG_REGISTER);
		handler.removeMessages(MSG_TIME_SLEEP_START);
		handler.removeMessages(MSG_TIME_SLEEP_FINISH);
	}



	//监听精度变化
	@Override
	public void onAccuracyChanged(Sensor sensor, int accuracy) {
		switch (sensor.getType()) {
		case Sensor.TYPE_ACCELEROMETER:
			Log.i(TAG, "* * *  注册加速传感器 ： " + accuracy);
			break;

		case Sensor.TYPE_PROXIMITY:
			Log.i(TAG, "# # #  注册距离传感器 ： " + accuracy);
			break;
			
		default:
			break;
		}
	}

	private long tt ;
	private long lt ;
	private int max = -10 ;
	private int min = -20 ;
	@Override
	public void onSensorChanged(SensorEvent event) {
		switch (event.sensor.getType()) {
		case Sensor.TYPE_PROXIMITY://距离感应器
//			LockUtils.vibrate(this);
			int value = (int) event.values[0];
			max = application.getLightMax() ;
			min = application.getLightMin();
//			Log.d(TAG, " $ $ $ value:"+value + "  max:"+ max + "  min:" + min);
			if(!application.isInitPro()){
				if(max<0&&min<0){
					max = value ;
					min = value ;
				}else if(value>max){
					max = value ;
				}else if(value<min){
					min = value ;
				}
				Log.i(TAG," # # # value:"+ value+ "  max:" + max +"   min:"+min);
				application.setLightMax(max);
				application.setLightMin(min);
			}
			if(isAppStop()
					||isSleepStop()){
				return ;
			}
			boolean cantLock = isRegister
					||!application.isLight()
					||(System.currentTimeMillis()-rpt<800)
					 ;
			Log.e(TAG," * * * value:"+ value+ "  max:" + max +"   min:"+min);
			if (cantLock) {
				Log.i(TAG, "-----------------"+(System.currentTimeMillis()-rpt)+"----------------");
				isRegister = false ;
				return;
			}

			lock = !isScreenOn();
			if(value==min){
				lt = System.currentTimeMillis();
			}
//			if (lock && distance == promixty.getMaximumRange()) // 距离大于5，解锁屏
			if (lock && value == max) // 距离大于5，解锁屏
			{
				if(application.isLater()){
					if(System.currentTimeMillis()-lt>=application.getAdjustLater()){
						lockScreen() ;
					}
				}else{
					lockScreen();
				}
				return ;
			}
//			if (!lock && distance == 0) // 距离小于0.5，锁屏
			if (!lock && value == min) // 距离小于0.5，锁屏
			{
//				lock();
				if(application.isLater()){
					handler.sendEmptyMessageDelayed(MSG_LATER, application.getAdjustLater());
				}else{
					lockScreen();
				}
				return ;
			}
			if(application.isLater()&&handler.hasMessages(MSG_LATER)){
				handler.removeMessages(MSG_LATER);
			}
			
			break;
			
		case Sensor.TYPE_ACCELEROMETER://加速传感器

			
			// 现在检测时间
			long currentUpdateTime = System.currentTimeMillis();
			
			
			long ti = currentUpdateTime - tt ;
			if(ti>1000*3){
//				LockUtils.vibrate(this);
//				Log.e(TAG, "AAAAAAAAAAAAAAAAAAAAAAA");
				tt = currentUpdateTime;
			}
					
			// 两次检测的时间间隔
			long timeInterval = currentUpdateTime - lastUpdateTime;
			// 判断是否达到了检测时间间隔
			if (timeInterval < UPTATE_INTERVAL_TIME)
				return;
			// 现在的时间变成last时间
			lastUpdateTime = currentUpdateTime;

			// 获得x,y,z坐标
			float x = event.values[0];
			float y = event.values[1];
			float z = event.values[2];

			// 获得x,y,z的变化值
			float deltaX = x - lastX;
			float deltaY = y - lastY;
			float deltaZ = z - lastZ;

			// 将现在的坐标变成last坐标
			lastX = x;
			lastY = y;
			lastZ = z;
			int adjust = LTApplication.getInstance().getAdjustShake();
			int SPEED_BASE = (int) (SPEED_SHRESHOLD + (adjust - 50.0) / 100 * 500);
			double speed = Math.sqrt(deltaX * deltaX + deltaY * deltaY + deltaZ
					* deltaZ)
					/ timeInterval * 10000;
			if(!isScreenOn()){
				SPEED_BASE /= 20 ;
			}
//			Log.v(TAG, adjust + "    ===log===   " + SPEED_BASE + "  ====  "
//					+ speed);
			// 达到速度阀值，发出提示
			
			if(!isScreenOn()){
				return ;
			}
			
			if (speed >= SPEED_BASE) {
				long current = System.currentTimeMillis();
				if (current - time < TIME_DISTANCE) {
					Log.e(TAG, "防止误操作");
//					LockUtils.vibrate(context);
					return;
				}
				time = current;
				if (application.isShake()&&isScreenOn()) {
					application.setLight(!application.isLight());
					if(application.isShock()){
						LockUtils.vibrate(context);
					}
					if(null!=viewHandler){
						viewHandler.sendEmptyMessage(Conf.MSG_VIEW_CHANGE);
					}
				}
			}
			break ;

		default:
			Sensor ss = event.sensor ;
			String valuess = "";
			for(int i = 0 ; i < event.values.length ; i++){
				valuess+= " "+i+":" +event.values[i];
			}
			Log.e(TAG, "onSensorChanged:"+ss.getName()+" values: "+valuess);
			break;
		}
		
		
	}

	// 跳至锁屏页面
	private void lockScreen() {
		if(LockUtils.isActive(this)){
			if(!isScreenOn()){
				unlock();
			}else{
				lock();
			}
			if(application.isShock()){
				LockUtils.vibrate(context);
			}
		}
			
	}
	
	
	
	
	private void lock(){
		if(application.isActive()){
			Log.i(TAG, " lock() * * * 锁屏 ");
			mDPM.lockNow();
			lock = true ;
			lt = System.currentTimeMillis();
		}
	}
	
	private KeyguardManager  keyguardManager ;// = (KeyguardManager) getSystemService(KEYGUARD_SERVICE);
	private WakeLock wakeLock;
	KeyguardLock keyguardLock ;//= keyguardManager.newKeyguardLock("");
	private void unlock(){
		Log.i(TAG, " unlock() - - - 点亮屏幕 ");
		//点亮屏幕
//		PowerManager pm = (PowerManager)getSystemService(POWER_SERVICE);
		wakeLock = pm.newWakeLock(PowerManager.ACQUIRE_CAUSES_WAKEUP|PowerManager.SCREEN_DIM_WAKE_LOCK, "open");
		
//		wakeLock.acquire();
		//wakeLock.release();
		//光感解锁
//		keyguardManager = (KeyguardManager) getSystemService(KEYGUARD_SERVICE);
//		KeyguardLock keyguardLock = keyguardManager.newKeyguardLock("");
//		keyguardLock.disableKeyguard();
		wakeLock.acquire(15000L);
		lock = false ;
		}
	
	
	/**
	 * 
	 *	@Create at  ：2013-10-28 下午4:21:42
	 *  @return
	 *	@Description：判断屏幕是否锁住
	 */
	private boolean isScreenOn(){
		PowerManager pm = (PowerManager)getSystemService(POWER_SERVICE);
		return pm.isScreenOn();
	}
	
	private void update() {
		long last = LTApplication.getInstance().getLastTime();
		if (System.currentTimeMillis() - last > Conf.TIME_DISTANCE
				&& Util.hasNetWork(this)) {
			new UpdateAsyncTaskTwo(handler).execute("");
		}
		next();
	}

	private void next() {
		handler.removeMessages(MSG_NEXT);
		handler.sendEmptyMessageDelayed(MSG_NEXT, 1000*60*60*24);
	}

	private void notification() {
		UpdateInfo updateInfo = (UpdateInfo) FileUtils
				.readObject(Conf.DATE_UPDATE);
		if (null == updateInfo||"0".equals(updateInfo.getSoft_tsup())) {
			return;
		}
		Intent intent = new Intent(this,UpdateActivity.class);
		pi = PendingIntent.getActivity(this, 0, intent, 0);
		notification.setLatestEventInfo(this,
				"LI光感解锁新版本" + updateInfo.getSoft_bate(),
				updateInfo.getSoft_content(), pi);
		mNotifMan.cancel(FLAG);
		mNotifMan.notify(FLAG, notification);
	}
	
	private long rpt ;
	private void registerListener(Sensor sensor){
		if(null!=sensor&&null!=sm){
			switch (sensor.getType()) {
			case Sensor.TYPE_PROXIMITY:
				if(isPro){
					return ;
				}
				isPro = true ;
				isRegister = true ;
				rpt = System.currentTimeMillis();
				break;
			case Sensor.TYPE_ACCELEROMETER:
				if(isAcc){
					return ;
				}
				isAcc = true ;
				break;

			default:
				break;
			}
			sm.registerListener(this, sensor, SensorManager.SENSOR_DELAY_NORMAL);
		}
	}
	
	
	private void unregisterListener(Sensor sensor){
		if(null!=sensor&&null!=sm){
			switch (sensor.getType()) {
			case Sensor.TYPE_PROXIMITY:
				if(isPro){
					isPro = false ;
					Log.e(TAG, "# # # 取消注册距离传感器 # # # ");
					sm.unregisterListener(this, sensor);
				}
				break;
			case Sensor.TYPE_ACCELEROMETER:
				if(isAcc){
					isAcc = false ;
					Log.e(TAG, "* * * 取消注册重力加速传感器 * * * ");
					sm.unregisterListener(this, sensor);
				}
				break;

			default:
				break;
			}
		}
	}
	
	
	
	private boolean isAppStop(){
		return LockUtils.isHorizontal() && application.isHorizontal()&& isScreenOn();
	}
	private boolean isSleepStop(){
		int now = Util.getNow() ;
		return application.isSleep()&& now > application.getSleepStart()&& now < application.getSleepFinish();
	}
	
	private void initSleepTime(){
		int now = Util.getNow();
		int day = 24*60 ;
		start = application.getSleepStart() - now;
		end = application.getSleepFinish() - now;
		start = start > 0 ? start : start + day ;
		end = end > 0 ? end : end + day ;
	}
	
	private void registerSleep(){
		Log.e(TAG, "~ ~ ~ registerSleep() ~ ~ ~ ");
		initSleepTime();
		unregisterSleep();
		if(application.isSleep()){
			handler.sendEmptyMessageDelayed(MSG_TIME_SLEEP_START, start*60*1000);
			handler.sendEmptyMessageDelayed(MSG_TIME_SLEEP_FINISH, end*60*1000);
		}
	}
	
	
	
	private void unregisterSleep(){
		handler.removeMessages(MSG_TIME_SLEEP_START);
		handler.removeMessages(MSG_TIME_SLEEP_FINISH);
	}
	
	class MyHandler extends Handler {
		@Override
		public void handleMessage(Message msg) {
			switch (msg.what) {
			case Conf.MSG_SUCCESS:
				Log.e(TAG, "~ ~ ~ MSG_SUCCESS ~ ~ ~ ");
				notification();
				break;
			case MSG_NEXT:
				Log.e(TAG, "~ ~ ~ MSG_NEXT ~ ~ ~ ");
				update();
				break;

			case MSG_LATER:
				Log.e(TAG, "~ ~ ~ MSG_LATER ~ ~ ~ ");
				lockScreen();
				break ;
				
				
			case MSG_TIME_SLEEP_START:
				registerSleep();
				Toast.makeText(context, "开始休眠！", Toast.LENGTH_LONG).show();
				Log.i(TAG, "。。。开始休眠。。。。");
				break ;
				
			case MSG_TIME_SLEEP_FINISH:
				registerSleep();
				Toast.makeText(context, "停止休眠！", Toast.LENGTH_LONG).show();
				Log.i(TAG, "。。。停止休眠。。。。");
				break ;
				
				
			case MSG_SLEEP_WAKE:
				Log.e(TAG, "~ ~ ~ MSG_SLEEP_WAKE ~ ~ ~ ");
				sleepWakeAlive();
				break ;
				
			default:
				break;
			}
		}

	}
	
	private void sleepWakeAlive(){
		if(handler.hasMessages(MSG_SLEEP_WAKE)){
			handler.removeMessages(MSG_SLEEP_WAKE);
		}
		if(application.isSleep()&&!isScreenOn()){
			Log.e(TAG, "*************保持唤醒**************");
			registerSleep();
			handler.sendEmptyMessageDelayed(MSG_SLEEP_WAKE, 1000*60*60);
		}
	}
	
	private void registerTimePick(){
		tiemReceiver = new TimePickBroadcastReceiver() ;
		IntentFilter filter = new IntentFilter() ;
		filter.addAction(Intent.ACTION_TIME_TICK);
		registerReceiver(tiemReceiver, filter);
	}
	
	private void unregisterTimePick(){
		unregisterReceiver(tiemReceiver);
	}


}
